% Joe Jupin
% Homework 9

clear all;

% declare Boolean matrix
% a harder cluster to test algorithm
BW = logical([0 1 1 0 0 0 0 1
              1 1 1 0 1 1 0 0
              1 1 1 0 1 1 0 0
              1 1 1 0 0 0 1 0
              1 1 0 0 0 0 1 0
              0 0 1 0 0 1 0 0
              0 1 1 0 1 0 0 1
              1 1 1 0 0 0 1 0]);
% get size of Boolean matrix
[rows cols]  = size(BW);
% make cluster marking array 1
pass1 = zeros(rows, cols);
% declare count for candidate clusters found
found = 0;

% pass 1 from top left to bottom right
% finding all left, upper left and upper
% neighbors to build candidate clusters
for i=1:rows
    for j=1:cols
        if BW(i,j) == 1
            % if first element in matrix
            if (i == 1) & (j == 1)
                % increase number of cluster candidates found
                found = found + 1;
                % assign new designated candidate cluster
                pass1(i,j) = found;
            % if element is in first row
            elseif i == 1
                % if left neighbor is in a cluster
                if pass1(i, j-1) > 0
                    % assign existing designated candidate cluster
                    pass1(i,j) = pass1(i, j-1);
                elseif pass1(i, j-1) == 0
                    % increase number of cluster candidates found
                    found = found + 1;
                    % assign new designated candidate cluster
                    pass1(i,j) = found;
                end
            % if element is in first column
            elseif j == 1
                % if upper neighbor is in a cluster
                if pass1(i-1, j) > 0
                    % assign existing designated candidate cluster
                    pass1(i,j) = pass1(i-1, j);
                elseif pass1(i-1, j) == 0
                    % increase number of cluster candidates found
                    found = found + 1;
                    % assign new designated candidate cluster
                    pass1(i,j) = found;
                end
            % else the element is not in first row or column
            else
                % if left neighbor is in a cluster
                if pass1(i,j-1) > 0
                    % assign existing designated candidate cluster
                    pass1(i,j) = pass1(i,j-1);
                % if upper left neighbor is in a cluster
                elseif pass1(i-1,j-1) > 0
                    % assign existing designated candidate cluster
                    pass1(i,j) = pass1(i-1,j-1);
                % if upper neighbor is in a cluster
                elseif pass1(i-1,j) > 0
                    % assign existing designated candidate cluster
                    pass1(i,j) = pass1(i-1,j);
                else
                    % increase number of cluster candidates found
                    found = found + 1;
                    % assign new designated candidate cluster
                    pass1(i,j) = found;
                end
            end
        end
    end
end

% make identity matrix to hold numbers
% that belong to the same final clusters
matches = eye(found);

% pass 2 from bottom left to top right
% to find all numbers that belong to
% the same final clusters
for i=rows:-1:1
    for j=1:cols
        % if element is in a candidate cluster
        if pass1(i,j) > 0
            % skip because an element is equal to itself
            if (i == 1) & (j == cols)
                ; % do nothing
            % if element is in first row
            elseif i == 1
                % if right neighbor is in a cluster mark as equal
                if (pass1(i, j+1) > 0) & (pass1(i, j+1) ~= pass1(i, j))
                    matches(pass1(i, j+1), pass1(i, j)) = 1;
                    matches(pass1(i, j), pass1(i, j+1)) = 1;
                end
            % if element is in last column
            elseif j == cols
                % if upper neighbor is in a cluster mark as equal
                if (pass1(i-1, j) > 0) & (pass1(i-1, j) ~= pass1(i, j))
                    matches(pass1(i-1, j), pass1(i, j)) = 1;
                    matches(pass1(i, j), pass1(i-1, j)) = 1;
                end
            % else element is not in first row or last column
            else
                % if right neighbor is in a cluster mark as equal
                if (pass1(i, j+1) > 0)  & (pass1(i, j+1) ~= pass1(i, j))
                    matches(pass1(i, j+1), pass1(i, j)) = 1;
                    matches(pass1(i, j), pass1(i, j+1)) = 1;
                % if upper right neighbor is in a cluster mark as equal
                elseif (pass1(i-1, j+1) > 0) & (pass1(i-1, j+1) ~= pass1(i, j))
                    matches(pass1(i-1, j+1), pass1(i, j)) = 1;
                    matches(pass1(i, j), pass1(i-1, j+1)) = 1;
                % if upper neighbor is in a cluster mark as equal
                elseif (pass1(i-1,j) > 0)  & (pass1(i-1, j) ~= pass1(i, j))
                    matches(pass1(i-1, j), pass1(i, j)) = 1;
                    matches(pass1(i, j), pass1(i-1, j)) = 1;
                end
            end
        end
    end
end

% make final cluster marking array pass2
pass2 = pass1;
% make array to hold replacement numbers
equals = zeros(found*2, 2);
% maintains row index position in equals array
n = 0;
% keeps track of which number will be placed
% into the final marking array
m = 1;
% shows that algorithm made valid choices
% for number extraction
t = zeros(found*2, 3);

% extract equal numbers from matches matrix
% and consolidate the set of numbers from
% 1 to n sequentially
for i=1:found
    % clear variables
    clear r;
    clear c;
    % check if candidate cluster element is
    % already in equals matrix
    [r, c] = find(equals == i);
    % count equal numbers in matches array
    s = sum(matches(i,(i+1):found));
    % save sum in t
    t(i,1) = s;
    % length of r in t
    if length(r) > 0
        t(i,2) = r;
    end
    % save present final cluster number in t
    t(i,3) = m;
    % if nothing else is equal
    if (s == 0) & (length(r) == 0)
        % increment final cluster number
        m = m + 1;
    % else something is equal
    else
        % traverse upper echelon matrix
        for j=i:found
            % if not on diagonal
            if i ~= j
                % if an equal is found
                if matches(i,j) == 1
                    % if not already in equals matrix
                    if length(r) == 0
                        % increment row in equals matrix
                        n = n + 1;
                        % set replacement number to present final cluster number
                        equals(n,1) = m;
                        % set number to be replaced
                        equals(n,2) = j;
                        % 
                        if m ~= i
                            % increment row in equals matrix
                            n = n + 1;
                            % set replacement number to present final cluster number
                            equals(n,1) = m;
                            % set number to be replaced
                            equals(n,2) = i;
                        end
                        % increment final cluster number
                        m = m + 1;
                    else
                        % increment row in equals matrix
                        n = n + 1;
                        % set replacement number to existing final cluster number
                        equals(n,1) = equals(r,1);
                        % set number to be replaced
                        equals(n,2) = j;
                    end
                end
            end
        end
    end
end

% replace equal cells from the first pass
% into the second pass matrix 
for i=1:rows
    for j=1:cols
        for k=1:n
            if equals(k,2) == pass1(i,j)
                pass2(i,j) = equals(k,1);
            end
        end
    end
end

% pass2 holds the clusters
pass2

% clear variables
clear c;
clear i;
clear j;
clear k;
clear m;
clear n;
clear r;
clear s;
clear t;
clear rows;
clear cols;
clear found;
%clear matches;
%clear equals;
clear pass1;